package ru.kristall.alfresco.module.bg.constraints;

import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.component.UIOutput;
import javax.faces.component.UISelectItems;
import javax.faces.component.UISelectOne;
import javax.faces.context.FacesContext;
import javax.faces.convert.Converter;

import org.alfresco.service.cmr.dictionary.Constraint;
import org.alfresco.service.cmr.dictionary.ConstraintDefinition;
import org.alfresco.service.cmr.dictionary.PropertyDefinition;
import org.alfresco.web.app.servlet.FacesHelper;
import org.alfresco.web.bean.generator.TextFieldGenerator;
import org.alfresco.web.ui.common.ComponentConstants;
import org.alfresco.web.ui.repo.component.property.PropertySheetItem;
import org.alfresco.web.ui.repo.component.property.UIPropertySheet;

import ru.kristall.alfresco.module.bg.constraints.*;

public class CustomKriListComponentGenerator extends TextFieldGenerator {

	
	public UIComponent generate(FacesContext context, String id) {
		 
		  UIOutput component = (UIOutput)context.getApplication().createComponent(
	      ComponentConstants.JAVAX_FACES_OUTPUT);
	      component.setRendererType(ComponentConstants.JAVAX_FACES_TEXT);
	      FacesHelper.setupComponentId(context, component, id);
	      return component;
	   }
	 
	   protected UIComponent createComponent(FacesContext context, UIPropertySheet propertySheet, PropertySheetItem item) {
	 
	      UIComponent component = null;
	 
	      if (propertySheet.inEditMode()) {
	 
	    	 ListOfKriConstraint constraint=this.getListOfValuesKri(context, propertySheet, item);
	 
	         PropertyDefinition propDef = this.getPropertyDefinition(context, propertySheet.getNode(), item.getName());
	 
	         if (constraint != null && item.isReadOnly() == false && propDef != null && propDef.isProtected() == false) {
	            component = context.getApplication().createComponent(UISelectOne.COMPONENT_TYPE);
	            FacesHelper.setupComponentId(context, component, item.getName());
	 
	            UISelectItems itemsComponent = (UISelectItems)context.getApplication().createComponent("javax.faces.SelectItems");
	 
	            itemsComponent.setValue(constraint.getSelectItemList());
	 
	            component.getChildren().add(itemsComponent);
	         }
	      }
	      else {
	         component = generate(context, item.getName());
	      }
	 
	      return component;
	   }
	 
	protected ListOfKriConstraint getListOfValuesKri(FacesContext context, UIPropertySheet propertySheet, PropertySheetItem item) {
	 
		  ListOfKriConstraint lovqConstraint = null;
	      PropertyDefinition propertyDef = getPropertyDefinition(context, propertySheet.getNode(), item.getName());
	 
	      if (propertyDef != null) {
	 
	         List<ConstraintDefinition> constraints = propertyDef.getConstraints();
	         for (ConstraintDefinition constraintDef : constraints) {
	 
	            Constraint constraint = constraintDef.getConstraint();
	            if (constraint instanceof ListOfKriConstraint) {
	            	lovqConstraint = (ListOfKriConstraint)constraint;
	               break;
	            }
	         }
	      }
	 
	      return lovqConstraint;
	   }	
	
	protected void setupConverter(FacesContext context, UIPropertySheet propertySheet, PropertySheetItem property, PropertyDefinition propertyDef, UIComponent component) {

	  super.setupConverter(context, propertySheet, property, propertyDef, component);
      if(!propertySheet.inEditMode() && propertyDef != null && component instanceof UIOutput) {
        ((UIOutput)component).setConverter((Converter) new ListOfValuesKriConverter(this.getListOfValuesKri(context, propertySheet, property)));
	  }
    }
	
}